"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Const = __importStar(require("./Consts"));
var Evaluator = /** @class */ (function () {
    function Evaluator() {
    }
    Evaluator.prototype.Evaluate = function (_key, _json, _defaultValue, _user) {
        // @ts-ignore <ts(2339)>
        var values = Object.values(_json);
        for (var _i = 0, values_1 = values; _i < values_1.length; _i++) {
            var value = values_1[_i];
            if (value['key'] === _key) {
                if (!value['is_targeting_enabled']) {
                    return value['state'];
                }
                if (_user) {
                    return this.EvaluateTargets(value['targets'], _user, value['state']);
                }
                break;
            }
        }
        return _defaultValue;
    };
    Evaluator.prototype.EvaluateTargets = function (_targets, _user, _defaultValue) {
        // @ts-ignore <ts(2339)>
        var targets = Object.values(_targets);
        var state = _defaultValue;
        var ruleResult = false;
        var evaluates = true;
        for (var _i = 0, targets_1 = targets; _i < targets_1.length; _i++) {
            var target = targets_1[_i];
            state = target['state'];
            if (target['rules']) {
                ruleResult = this.EvaluateRules(target['rules'], _user);
                evaluates = evaluates && ruleResult;
            }
        }
        if (evaluates) {
            return state;
        }
        return _defaultValue;
    };
    Evaluator.prototype.EvaluateRules = function (_rules, _user) {
        // @ts-ignore <ts(2339)>
        var rules = Object.values(_rules);
        var result = false;
        for (var _i = 0, rules_1 = rules; _i < rules_1.length; _i++) {
            var rule = rules_1[_i];
            var userAttributeValue = this.GetUserAttributeValue(rule['attribute'], _user);
            if (!userAttributeValue)
                continue;
            var comparator = rule['comparator'];
            var values = rule['values'];
            switch (comparator) {
                case Const.COMPARATOR_EQUAL_TO:
                    result = values.includes(userAttributeValue);
                    break;
                case Const.COMPARATOR_NOT_EQUAL_TO:
                    result = !values.includes(userAttributeValue);
                    break;
                case Const.COMPARATOR_CONTAINS:
                    for (var _a = 0, values_2 = values; _a < values_2.length; _a++) {
                        var value = values_2[_a];
                        result = userAttributeValue.includes(value);
                        if (result)
                            break;
                    }
                    break;
                case Const.COMPARATOR_NOT_CONTAIN:
                    var valid = true;
                    for (var _b = 0, values_3 = values; _b < values_3.length; _b++) {
                        var value = values_3[_b];
                        result = !userAttributeValue.includes(value);
                        valid = result && valid;
                    }
                    result = valid;
                    break;
                default:
                    result = false;
                    break;
            }
        }
        return result;
    };
    Evaluator.prototype.GetUserAttributeValue = function (_key, _user) {
        if (_key.toLowerCase() === "email") {
            return _user.email;
        }
        if (_user.custom && _user.custom[_key.toLowerCase()].toLowerCase()) {
            return _user.custom[_key];
        }
        return null;
    };
    return Evaluator;
}());
exports.Evaluator = Evaluator;
